# module ActiveRecord::AttributeMethods::Read

### Public Instance Methods

_read_attribute(attr_name, &block) click to toggle source

This form is significantly faster on JRuby, and this is one of our biggest hotspots. github.com/jruby/jruby/pull/2562

    # File lib/active_record/attribute_methods/read.rb, line 66
    def _read_attribute(attr_name, &block) # :nodoc
      @attributes.fetch_value(attr_name.to_s, &block)
    end

Also aliased as: attribute
read_attribute(attr_name, &block) click to toggle source

Returns the value of the attribute identified by `attr_name` after it has been typecast (for example, “2004-12-12” in a date column is cast to a date object, like Date.new(2004, 12, 12)).

    # File lib/active_record/attribute_methods/read.rb, line 50
    def read_attribute(attr_name, &block)
      name = if self.class.attribute_alias?(attr_name)
        self.class.attribute_alias(attr_name).to_s
      else
        attr_name.to_s
      end

      name = self.class.primary_key if name == "id".freeze && self.class.primary_key
      _read_attribute(name, &block)
    end

### Private Instance Methods

attribute(attr_name, &block)
Alias for: _read_attribute